from typing import Self, TypeVar, Generic, Protocol

class object:
    def __eq__(self, other: Self) -> bool: ...
    def __ne__(self, other: Self) -> bool: ...

class int:
    def __add__(self, other: Self) -> Self: ...

    def __sub__(self, other: Self) -> Self: ...

    def __mul__(self, other: Self) -> Self: ...

    def __and__(self, other: Self) -> Self: ...

    def __neg__(self) -> Self: ...
    def __init__(self, x: str) -> None: ...
    def __lt__(self, other: Self) -> bool: ...
    def __gt__(self, other: Self) -> bool: ...


assert int.__add__
U = TypeVar("U")
V = TypeVar("V")

class slice:
    pass


class HasLen(Protocol):
    def __len__(self) -> int: ...

def len(x: HasLen) -> int:
    ...

class Iterator(Protocol[U]):
    def __iter__(self) -> Self: ...

    def __next__(self) -> U: ...

class Iterable(Protocol[U]):
    def __iter__(self) -> Iterator[U]: ...

class str:
    def find(self, sub: Self) -> int: ...
    def format(self, *args) -> Self: ...
    def encode(self, encoding: Self) -> bytes: ...
    def __len__(self) -> int: ...
    def __add__(self, other: Self) -> Self: ...
    def __mul__(self, other: int) -> Self: ...
    def startswith(self, prefix: Self) -> bool: ...
    def __getitem__(self, item: int | slice) -> Self: ...

assert len("a")

class bytes:
    def decode(self, encoding: str) -> str: ...
    def __len__(self) -> int: ...

class list(Generic[U]):

    def __add__(self, other: Self) -> Self: ...

    def __mul__(self, other: int) -> Self: ...

    def __getitem__(self, index: int) -> U: ...
    def __setitem__(self, index: int, value: U) -> None: ...

    def pop(self, index: int = -1) -> U: ...
    def __iter__(self) -> Iterator[U]: ...
    def __len__(self) -> int: ...
    def append(self, value: U) -> None: ...
    def __contains__(self, item: U) -> bool: ...

assert [1, 2].__iter__()
assert list[int].__iter__

class dict(Generic[U, V]):
    def __getitem__(self, key: U) -> V: ...
    def __setitem__(self, key: U, value: V) -> None: ...
    def __len__(self) -> int: ...


assert(len(["a"]))

assert [1, 2, 3][1]


def iter(x: Iterable[U]) -> Iterator[U]:
    ...

assert iter

def next(it: Iterator[U], default: None) -> U:
    ...
# what happens with multiple functions

assert iter(["1", "2"])

def identity(x: U) -> U:
    ...

assert identity(1)
assert identity("a")

def identity_2(x: U, y: V) -> tuple[U, V]:
    ...

assert list.__add__
assert list.__add__([5], [[6][0]])
#assert list[U].__add__
assert list[int].__add__
assert identity_2(1, "a")
assert lambda x, y: identity_2(x, y)
assert lambda x: identity_2(x, x)

def print(*args) -> None: ...

assert print


def range(*args) -> Iterator[int]: ...

assert [].__add__
assert [6].__add__
assert [True].__add__
assert lambda x: [x].__add__



assert next(range(6), None)

class file:
    def read(self, size: int=0) -> Task[str]: ...
    def close(self) -> Task[None]: ...
    def __enter__(self) -> Self: ...
    def __exit__(self) -> Task[bool]: ...

def open(filename: str, mode: str) -> Task[file]: ...

def __test_opt(x: int, y: int = 5) -> int:
    ...

assert __test_opt
assert __test_opt(5)
assert __test_opt(5, 6)
assert not __test_opt(5, 6, 7)
assert not __test_opt()

class __test_type:
    def __init__(self) -> None: ...

    def test_opt(self, x: int, y: int = 5) -> int:
        ...

assert __test_type().test_opt(5)
assert __test_type().test_opt(5, 6)
assert not __test_type().test_opt(5, 6, 7)
assert not __test_type().test_opt()